import unittest
from cmdline import ConfigSetter

class _Config:
    pass

class TestConfig(unittest.TestCase):
    def _get_config(self):
        conf = _Config()
        conf.bob = 3
        conf.general = _Config()
        conf.general.rabbit = "moo"
        return conf

    def test_simple_set(self):
        conf = self._get_config()
        command = ConfigSetter(conf, '')
        command.add_flag(None, 'rabbit', 'some desc', 'general.rabbit', str)
        command.add_argument('BOB', 'some desc', 'bob')
        self.assertEqual(None, command.invoke(args=['--rabbit=goes bonk', 'the builder']))
        self.assertEqual('goes bonk', conf.general.rabbit)
        self.assertEqual('the builder', conf.bob)

    def test_missing_config(self):
        conf = self._get_config()
        error = []
        command = ConfigSetter(conf, '')
        self.assertRaises(ValueError, command.add_flag, 'm', None, 'some desc', 'missing')
