from pycro.backend.builder import builder
from pycro.backend.operations.softwareinterrupt import SoftwareInterrupt

@builder(args=["exit_code"])
def exit(codegen, function, variables):
    """ Called to implement the backends sys.exit """
    assert len(variables) == 1
    variables[0].push()
    SoftwareInterrupt(codegen).exit()

    # Even though we never reach this point, we still need to finish off the
    # function...
    codegen.push_data(0)
    function.ret()
