import pycro.backend.codegen as cgen
from pycro.backend.builder import builder
from pycro.backend.operations.integer import Integer
import pycro.backend.operations.softwareinterrupt as si

@builder(args=[])
def peek(codegen, function, variables):
    # al is equal to 0xff if a key is available
    si.SoftwareInterrupt(codegen).trigger_dos_interrupt(0x0B)
    codegen.push(cgen.Register.AX)
    codegen.push_data(0xff)
    Integer(codegen).binary_and()
    codegen.push_data(0xff)
    Integer(codegen).equal()
    function.ret()

@builder(args=[])
def readkey(codegen, function, variables):
    si.SoftwareInterrupt(codegen).trigger_dos_interrupt(0x08)
    codegen.push(cgen.Register.AX)
    codegen.push_data(0xff)
    Integer(codegen).binary_and()
    function.ret()

