#!env python
import unittest
from pycro.backend.operations.softwareinterrupt import SoftwareInterrupt
from pycro.backend.codegen import CodeGen
from pycro.backend.test.comfile import write_and_run, run

class TestSoftwareInterrupt(unittest.TestCase):

    def test_return_value(self):
        
        generator = CodeGen()

        generator.push_data(1)
        SoftwareInterrupt(generator).exit()
        self.assertEqual(1, write_and_run(generator.create_output()))

        generator = CodeGen()
        generator.push_data(0)
        SoftwareInterrupt(generator).exit()
        self.assertEqual(0, write_and_run(generator.create_output()))

        generator = CodeGen()
        generator.push_data(4)
        SoftwareInterrupt(generator).exit()
        self.assertEqual(4, write_and_run(generator.create_output()))

    def test_print_chr(self):
        
        generator = CodeGen()

        for char in "rabbit":
            generator.push_data(ord(char))
            SoftwareInterrupt(generator).print_chr()

        generator.push_data(0)
        SoftwareInterrupt(generator).exit()

        (exit_code, output) = run(generator.create_output()) 
        self.assertEqual(0, exit_code)
        self.assertEqual("rabbit", output)

if __name__ == '__main__':
    unittest.main()

