
import os.path
import stat
import subprocess


def run(code):
    """ Run the output, returning a tuple containing the exit code
        and the program output. """
    file_name = os.path.join(os.getcwd(), "test.com")
    outp = open(file_name, "wb")
    outp.write("".join(chr(byte) for byte in code))
    outp.close()
    os.chmod(file_name, stat.S_IRWXU)

    process = subprocess.Popen(args=[file_name], stdout=subprocess.PIPE)
    output = process.stdout.read()
    exit_code = process.wait()
    os.remove(file_name)
    return (exit_code, output)

def write_and_run(output):
    """ Write a set of instructions to disk, and run them. We write
        the instructions to a .com file, as these files have no
        header (they are pure instructions). """
    return run(output)[0]
