
import pycro.backend.operations.list as lst
from pycro.frontend.python.builtins import builtin_attr, builtin_attr_generator, named_builder

@builtin_attr
def insert(list, index, value):
    i = len(list)
    list.append(0)
    while i >= index:
        list[i+1] = list[i]
        i = i - 1
    list[index] = value

@builtin_attr_generator(['self', 'value'], "append")
def builtin_append(codegen, function, variables):
    lst.append(codegen, function, variables)

@builtin_attr
def reverse(list):
    i = 0
    total = len(list) / 2
    while i < total:
        temp = list[i]
        list[i] = list[len(list) - i - 1]
        list[len(list) - i - 1] = temp
        i = i + 1

@named_builder(["self"], "len")
def builtin_len(codegen, function, variables):
    assert len(variables) == 1
    variables[0].push()
    lst.length(codegen)
    function.ret()
