
from pycro.frontend.python.builtins import builtin

@builtin
def str(value):
    # HACK: Convert an integer to a string. Works on the fact that
    # we know strings are internally integers, so we'll create a
    # list with the required characters.
    #
    # Note: This hack only works for str(integer)!

    zero = 48 # ord('0')
    
    is_negative = False
    if value < 0:
        value = 0 - value
        is_negative = True

    characters = []
    if value == 0:
        characters.append(zero)

    while value != 0:
        character = value % 10 + zero
        characters.append(character)
        value = value / 10

    if is_negative:
        neg = 45 # ord('-')
        characters.append(neg)

    characters.reverse()
    return characters

@builtin
def hex(value):
    # HACK: Convert an integer to a hex string. Works on the fact that
    # we know strings are internally integers, so we'll create a
    # list with the required characters.

    zero = 48 # ord('0')
    
    is_negative = False

    x = 120 # ord('x')
    a = 97 # ord('a')
    characters = []
    if value == 0:
        characters.append(zero)

    while value != 0:
        character = value & 0xf
        if character >= 10:
            char = a + character - 10
        else:
            char = zero + character
        characters.append(char)
        value = value >> 4

    characters.append(x)
    characters.append(zero)
    characters.reverse()
    return characters

@builtin
def ord(value):
    assert len(value) == 1
    return value[0]
