
import pycro.backend.operations.asserter as asrt
import pycro.backend.operations.string as string
import pycro.backend.variable as var
from pycro.frontend.python.opcodes import opcode_with_index

@opcode_with_index('RAISE_VARARGS')
def assertion(state, codegen, num_args, code, bcc):
    if num_args == 1:
        # We aren't passing any messages, so add one...
        string.add_string_reference(codegen, "")
        num_args = 2
    elif num_args != 2:
        raise Exception("Cannot raise exceptions with more then one parameter...")

    message = var.StackVariable(codegen)
    asrt.failure(codegen, message)

    for i in range(num_args):
        codegen.pop_data()
