import dis
import pycro.backend.operations.integer as integer
from pycro.frontend.python.opcodes import opcode

@opcode('COMPARE_OP')
def compare(state, codegen, code, bcc):
    index = code.pop_index()
    lookup = {'<' : integer.Integer.lesser,
        '<=' : integer.Integer.lesser_equal,
        '==' : integer.Integer.equal,
        'is' : integer.Integer.equal, # Treat 'is' as equals
        'is not' : integer.Integer.not_equal, # Treat 'is not' as not equals
        '!=' : integer.Integer.not_equal,
        '>' : integer.Integer.greater,
        '>=' : integer.Integer.greater_equal}

    operation = dis.cmp_op[index]
    if operation not in lookup:
        raise Exception("Unimplemented comparision function '%s'" % operation)

    lookup[operation](integer.Integer(codegen))

