from pycro.frontend.python.opcodes import opcode, opcode_with_index
import pycro.backend.function as function

@opcode('RETURN_VALUE')
def return_value(state, codegen, code, bcc):
    state.add_return()

@opcode_with_index('MAKE_FUNCTION')
def make_function(state, codegen, num_default_params, code, bcc):
    assert num_default_params == 0

@opcode_with_index('CALL_FUNCTION')
def call_function(state, codegen, index, code, bcc):
    num_args = index & 0xff
    num_positional = (index >> 8)

    if num_positional != 0:
        raise Exception("Keyword arguments are not supported")

    function.Call(codegen).call(num_args)
