#!env python
import unittest

from pycro.frontend.python.test.run import run

class TestForLoop(unittest.TestCase):
    def test_simple_for_loop(self):
        def bob():
            items = [1, 2, 3, 4]
            total = 0
            for i in items:
                total = total + i
            return total
        self.assertEqual(10, run(bob))

    def test_empty_for_loop(self):
        def bob():
            items = []
            result = 7
            for i in items:
                total = total + i
            return result
        self.assertEqual(7, run(bob))

    def test_inplace_for_loop(self):
        def bob():
            result = 0
            for i in [1, 2, 3, 4]:
                result = result + i
            return result
        self.assertEqual(10, run(bob))

    def test_for_in_for(self):
        def bob():
            items = [0, 1]
            result = 0
            for i in [1, 2, 3, 4]:
                for j in items:
                    result = result + j * i
            return result
        self.assertEqual(10, run(bob))

if __name__ == "__main__":
    unittest.main()
