#!env python
import unittest
from pycro.frontend.python.test.run import run

class TestIfBlock(unittest.TestCase):
    def test_if_true(self):
        def bob():
            i = 3
            if i == 3:
                i = 7
            return i
        self.assertEqual(7, run(bob))

    def test_if_false(self):
        def bob():
            i = 0
            if not i:
                i = 9
            return i
        self.assertEqual(9, run(bob))

    def test_if_else(self):
        def bob():
            i = 0
            if i == 2:
                i = 6
            else:
                i = 5
            return i
        self.assertEqual(5, run(bob))

    def test_if_elif(self):
        def bob():
            i = 0
            if i == 1:
                i = 7
            elif i == 0:
                i = 6
            return i
        self.assertEqual(6, run(bob))

    def test_if_elif_else(self):
        def bob():
            i = 0
            if i == 1:
                i = 7
            elif i == 2:
                i = 6
            else:
                i = 5
            return i
        self.assertEqual(5, run(bob))

if __name__ == "__main__":
    unittest.main()
