#!env python
import unittest
from pycro.frontend.python.test.run import run

class TestWhileLoop(unittest.TestCase):
    def test_false_conditional(self):
        def bob():
            i = 0
            j = 5
            while i:
                j = 7
            return j
        self.assertEqual(5, run(bob))
                
    def test_true_conditional(self):
        def bob():
            i = 1
            j = 5
            while i:
                j = 7
                i = 0
            return j
        self.assertEqual(7, run(bob))

    def test_loop(self):
        def bob():
            i = 0
            last = 0
            j = 1
            while i < 5:
                i = i + 1

                old = j
                j = last + j
                last = old
            return j
        self.assertEqual(8, run(bob))

    def test_loop_in_loop(self):
        def bob():
            i = 0
            total = 0
            while i < 10:
                j = 0
                while j < 5:
                    total = total + 1
                    j = j + 1
                i = i + 1
            return total
        self.assertEqual(50, run(bob))

    def test_while_in_while(self):
        def bob():
            i = 0
            while i < 5:
                while 0:
                    i = 10
                i = 6
            return i
        self.assertEqual(6, run(bob))
            
    def test_continue_in_if(self):
        def bob():
            i = 0
            total = 0
            while i < 10:
                i = i + 1
                if i < 5:
                    continue
                total = total + 1
            return total
        self.assertEqual(6, run(bob))

if __name__ == "__main__":
    unittest.main()
