from pycro.frontend.python.opcodes import opcode_with_index, opcode

@opcode_with_index('STORE_FAST')
def store_fast(state, codegen, index, code, bcc):
    state.get_variable(index).pop()

@opcode_with_index('LOAD_FAST')
def load_fast(state, codegen, index, code, bcc):
    state.get_variable(index).push()

@opcode('POP_TOP')
def pop_variable(state, codegen, code, bcc):
    """ Used when we have a variable on the stack that won't be used... """
    codegen.pop_data()
