import dis
from pycro.frontend.python.opcodes import opcode_with_index
 
@opcode_with_index('SETUP_LOOP')
def loop_statement(state, codegen, loop_end, code, bcc):
    # We don't special case while loop statements... the jump
    # to label statements work fine. We'll just remove the
    # 'POP BLOCK' statement...
    #
    # We'll probably need to keep track of the blocks once
    # we handle 'break' statements...
    assert code.peek(loop_end - 1) == dis.opname.index('POP_BLOCK')
    code.remove(loop_end - 1)
