#!env python
import unittest

from pycro.frontend.python.test.run import run, output

class TestBuiltins(unittest.TestCase):
    def test_min(self):
        def bob():
            return min(0, 1)
        self.assertEqual(0, run(bob))

        def bob():
            return min(1, 1)
        self.assertEqual(1, run(bob))

        def bob():
            return min(2, 1)
        self.assertEqual(1, run(bob))

    def test_max(self):
        def bob():
            return max(3, 7)
        self.assertEqual(7, run(bob))

    def test_hex(self):
        def bob():
            print hex(2)
        
        self.assertEqual("0x2\n", output(bob))

        def bob():
            print hex(0xa2)
        self.assertEqual("0xa2\n", output(bob))

if __name__ == "__main__":
    unittest.main()
