#!env python
import unittest
from pycro.frontend.python.test.run import run

class TestOperations(unittest.TestCase):
    def test_add(self):
        def func():
            i = 5 + 3
            i = 7 + i
            return i
        self.assertEqual(15, run(func))

    def test_subtract(self):
        def func():
            i = 51 - 3
            return i
        self.assertEqual(48, run(func))

    def test_divide(self):
        def func():
            i = 8 / 4
            i = 24 / i
            return i
        self.assertEqual(12, run(func))

    def test_signed_divide(self):
        def func():
            i = -8 / -4
            return i == 2
        self.assertEqual(1, run(func))

    def test_divide_rounding(self):
        def func():
            i = 8 / 3
            return i
        self.assertEqual(2, run(func))

    def test_mod(self):
        def func():
            return 15 % 12
        self.assertEqual(3, run(func))

    def test_bimdas(self):
        def func():
            return 1 + 9 * (3 - 3 % 2) / 3
        self.assertEqual(7, run(func))

if __name__ == '__main__':
    unittest.main()
