#!env python
from sys import exit
from system.clock import sleep
from system.drawing.window import init, set_pixel, refresh
from system.input import peek, readkey

from common.clock import get_millseconds_step
from pacmanlib.drawing import clear_screen, draw_line, set_colour

res_x = 320
res_y = 200

def adjust_increment(pos, increment, duration, max):
    # Maybe we could adjust by a random amount?
    pos = pos + increment * duration
    if pos >= max * 100:
        increment = 0 - increment
    if pos < 0:
        increment = 0 - increment
    return increment

def main():
    init()
    clear_screen()

    # Keep trace of x & y in 100ths of a pixel
    balls = [[res_x * 100 / 5 * 1, 30, res_y * 100 / 2, 30],
             [res_x * 100 / 5 * 2,-20, res_y * 100 / 2,-40],
             [res_x * 100 / 5 * 3, 40, res_y * 100 / 2,-10],
             [res_x * 100 / 5 * 4,-25, res_y * 100 / 2, 10],
            ]
    x = 0
    x_incr = 1
    y = 2
    y_incr = 3

    should_run = 1
    while should_run:
        tick = get_millseconds_step()
        colour = 1
        for ball in balls:
            ball[x_incr] = adjust_increment(ball[x], ball[x_incr], tick, res_x)
            ball[y_incr] = adjust_increment(ball[y], ball[y_incr], tick, res_y)
            ball[x] = ball[x] + ball[x_incr] * tick
            ball[y] = ball[y] + ball[y_incr] * tick

            set_colour(colour)
            draw_line(ball[x] / 100, ball[y] / 100, ball[x] / 100, ball[y] / 100, 10)
            colour = colour + 1
        refresh()
        sleep(10)

        if peek():
            if readkey() == 27:
                should_run = 0
            workaround = 0
        workaround = 0

main()
