from common.matrix import identity, multiply, create_matrix, transform
from common.graphics.triangle import draw_triangle

_transformed_vertices = []

def _get_transformed_buffer(size):
    while len(_transformed_vertices) < size:
        column = [0,0,0]
        _transformed_vertices.append(column)
    return _transformed_vertices

def _get_transformed_vertices(vertices):
    i = 0
    transformed = _get_transformed_buffer(len(vertices))
    while i < len(vertices):
        transform(vertices[i], transformed[i], _world_transform)
        z = transformed[i][2] / 40
        transformed[i][0] = 160 + transformed[i][0] / z
        transformed[i][1] = 100 - transformed[i][1] / z
        transformed[i][2] = transformed[i][2] / 32
        i = i + 1
    return transformed

def render(vertices, triangles, colour):
    transformed = _get_transformed_vertices(vertices)
    colour = 1
    for triangle in triangles:
        v1 = transformed[triangle[0]]
        v2 = transformed[triangle[1]]
        v3 = transformed[triangle[2]]

        draw_triangle(v1[0], v1[1], v1[2], v2[0], v2[1], v2[2], v3[0], v3[1], v3[2], colour)
        colour = colour + 1

_world_transform = identity
def set_world_transform(matrix):
    global _world_transform
    _world_transform = matrix

