
_sin_lookup = [ 0,9,17,26,34,42,50,57,64,71,77,82,87,91,94,97,98,100,100 ]
_degree_step = 5

def _intepolate(value):
    lookup = value / _degree_step
    if lookup == len(_sin_lookup) - 1:
        return _sin_lookup[lookup]

    rem = value % _degree_step
    a = _sin_lookup[lookup]
    b = _sin_lookup[lookup + 1]
    return (a * (_degree_step - rem) + rem * b) / _degree_step

def sin(degrees):
    """ Get the sin value of a given degree rotation, multiplied by 100 """
    degrees = degrees % 360
    if degrees < 90:
        return _intepolate(degrees)
    if degrees < 180:
        return _intepolate(180 - degrees)
    if degrees < 270:
        return 0 - _intepolate(degrees - 180)
    return 0 - _intepolate(360 - degrees)

def cos(degrees):
    return sin(degrees + 90)
