from pacmanlib.drawing import draw_line, set_colour, clear_screen

_grid_size = 320  / 8

def draw_grid(x1, y1, x2, y2):
    width = 10
    draw_line(x1 * _grid_size, y1 * _grid_size, 
            x2 * _grid_size, y2 * _grid_size, width)

def draw_background():
    clear_screen()
    set_colour(6)

    # Draw borders around the edge of the screen
    draw_grid(0, 0, 8, 0)
    draw_grid(8, 0, 8, 6)
    draw_grid(8, 6, 0, 6)
    draw_grid(0, 6, 0, 0)

    # Top left border
    draw_grid(1, 1, 3, 1)
    draw_grid(1, 1, 1, 2)

    # Top right border
    draw_grid(5, 1, 7, 1)
    draw_grid(7, 1, 7, 2)

    # Middle square
    draw_grid(2, 2, 6, 2)
    draw_grid(6, 2, 6, 4)
    draw_grid(6, 4, 2, 4)
    draw_grid(2, 4, 2, 2)

    # Bottom left border
    draw_grid(1, 4, 1, 5)
    draw_grid(1, 5, 3, 5)

    # Top right border
    draw_grid(5, 5, 7, 5)
    draw_grid(7, 5, 7, 4)

    # Lines at the middle of each border
    draw_grid(4, 0, 4, 1)
    draw_grid(7, 3, 8, 3)
    draw_grid(4, 5, 4, 6)
    draw_grid(0, 3, 1, 3)


def draw_pacman(x, y):
    set_colour(7)
    x = x * _grid_size + _grid_size / 2
    y = y * _grid_size + _grid_size / 2
    size = 18
    draw_line(x - size / 2, y, x + size / 2, y, size)

