from system.drawing.window import set_pixel

_screen_width = 320
_screen_height = 200

def clear_screen():
    y = 0
    while y < _screen_height:
        x = 0
        while x < _screen_width:
            set_pixel(x, y, 0)
            x = x + 1
        y = y + 1

_colour = 5
def set_colour(colour):
    global _colour
    _colour = colour

def draw_line(x1, y1, x2, y2, width):
    # At the moment we only handle vertical or horizontal lines
    if x1 == x2:
        # Vertical line
        if y1 > y2:
            temp = y1
            y1 = y2
            y2 = temp
        left = max(0, x2 - width / 2)
        right = min(_screen_width, x2 + width / 2)

        top = max(0, y1 - width / 2)
        bottom = min(_screen_height, y2 + width / 2)
    else:
        # Horizontal line
        if x1 > x2:
            temp = x1
            x1 = x2
            x2 = temp

        left = max(0, x1 - width / 2)
        right = min(_screen_width, x2 + width / 2)
     
        top = max(0, y2 - width / 2)
        bottom = min(_screen_height, y2 + width / 2)

    # Draw the actual line
    y1 = top 
    while y1 < bottom:
        x1 = left
        while x1 < right:
            set_pixel(x1, y1, _colour)
            x1 = x1 + 1
        y1 = y1 + 1
